<?
  /****************************************************************************
   *
   * phpBB Back Up v1.08 (August 17, 2004)
   *  MMIII - MMIV by TerraFrost. All rights reserved.
   *
   * Description:
   * If you have ever tried to back up / restore a large phpBB board,
   * you are probably aware of some of the difficulties involved.  For one,
   * most HTTP servers have an upload limit of around 1MB.  If you try
   * to upload anything more than this, you'll get a time out error.  For 
   * two, if you're restoring the board via phpBB, the restore function can't
   * be accessed if there's a problem with the database.  Finally, if you are
   * trying to fix some code that messes up your database, taking the
   * several minutes it can take to restore the database through the
   * admin control panel of phpBB, through phpMyAdmin, or perhapes
   * through the command line simply isn't going to be very attractive.
   *
   * This script attempts to rectitify these situations by, among other
   * things, storing the backed up database locally, on the server, itself,
   * and in doing so, bypasses the size limitations of phpBB and phpMyAdmin.
   * The advantage this script has over the command line is that it is far
   * more convenient (indeed - this is also an advantage over phpMyAdmin).
   *
   * Usage is fairly straight foward.  Upload this file to the server, chmod 
   * the phpBB directory to 757, and then back up the database!  Restore as 
   * necessary.  If you need to transfer servers, or something, just download all
   * the contents of the phpBB directory, upload them to the new server, and run 
   * this script (this script will run without a database installed).
   *
   * Changelog:
   * x.xx: - clean up code for simultanious reading / writting of files.
   *       - allow for config.php file to be updated, as necessary.
   *       - update verification to ask for both lower case conversion of random
   *         string and for user to type in what they want done (ie. backup / restore)
   * 1.08: - updated comments in backup-cfg.php
   *       - updated instructions on transfering phpBB to a new host.
   *       - the path of the .hwpasswd file is now correctly defined in the password_protect
   *         function.
   *       - now works on phpBB 2.0.10.
   * 1.07: - automatic backups can now be made on boards that don't use phpbb_ as their
   *         table prefix (thanks to G.L.I.F.QЙ for helping me figure this out)
   *       - automatic backups now backup even the post that initiated the backup.
   * 1.06: - updated how backup upload locations are accessed.
   * 1.05: - autobackups now work with boards whose location doesn't have a / at the
   *         end of it (thanks to odie3 for helping me figure this problem out)
   *       - the backup creation code has been split off into its own function
   *       - added code which should make this script work with cron jobs.
   * 1.04: - rewrote the part of this hack that requires modifying functions_post.php
   * 1.03: - ftp_close only occurs if the function exists
   *       - $interval variable in backup-cfg.php function now works.
   * 1.02: - backups can now be placed on remote server (requested by Murrian)
   *       - instead of appending a random string to itself to backup, you have to type
   *         the reverse of that string
   *       - fixed a bug in one of the many authentication routines
   *       - backup's can now occur every x posts (requested by Murrian)
   *       - configuration now utilizes a seperate file - backup-cfg.php
   * 1.01: - added weeks to the part of the program that displays the age of the backup.
   *       - disabled feature that would allow for config.php file to be updated, as
   *         necessary.
   *       - made it easier to specify who can make backups on a per user basis.
   * 1.00: - initial release
   *
   * Comments, criticisms, suggestions, and additions welcome! Post them 
   * here:
   *
   * http://www.frostjedi.com/phpbb/viewforum.php?f=6
   *
   * Permission to use, copy, modify, and distribute this script and its for any 
   * purposes and without fee is hereby granted provided that all copyright 
   * notices that appear in this script are retained.
   *
   * Further, no representations or warranties about the suitability of this
   * script, either express or implied, including but not limited to the implied
   * warranties of merchantability, fitness for a particlar purpose, or non-
   * infringement are made.  Neither TerraFrost nor the Frost Jedi shall be
   * liable for any damages suffered by licensee as a result of using,
   * modifying or distributing this software or its derivatives.
   *
   ***************************************************************************/

   include($phpbb_root_path . "backup-cfg.php");

   //error_reporting(E_ALL); 

   define('IN_PHPBB', true);
   $phpbb_root_path='./';
   include($phpbb_root_path.'extension.inc');
   include($phpbb_root_path.'config.'.$phpEx);

   if ( ($_SERVER['REMOTE_ADDR'] == gethostbyname($_SERVER['SERVER_NAME']) && isset($_GET['mode']) && $_GET['mode'] == "backup")
       || ($argv[1] == "-mode" && $argv[2] == "backup"))
      create_backup();

   // commented out by omega13a (Sept. 11, 2004)
	 /*if( !strstr($dbms, "mysql") )
      if( !isset($bypass) ) {
         print "Database Doesn't Use MySQL...  Terminating Script.";
         exit;
      }*/

   /* in order to ensure the fact that backup's and restore's are only made when they're supposed to be made
    * this script does a number of things.  first, it uses POST, instead of GET, so you can't just copy / paste
    * a URL that someone could accidently click on that would restore / backup the database.  on older
    * browsers, this also prevents an accidental backup / restore by hitting the refresh button.  however, on
    * newer browsers, it doesn't.  newer browsers attempt to resend the previous POST data that was sent.
    * the following code (and code placed at other parts of this script) attempt to rectify that situation by keeping
    * track of how many times the script has been run and by including, in the POST data that is sent, how many
    * times the program should have been run in order for the backup / restore to take place.  if these values do
    * not match, you will be redirected to the index page.
    */

   $key = 0;
   $pathname = "./backup/";
   $filename = "key";
   if (file_exists($pathname . $filename)) {
      $fp = fopen($pathname . $filename, "r");
      $bbKey = (int) fgets($fp,1024);
      fclose($fp);
   } else {
      if (!strcmp($username,""))
         $username = $dbuser;
      if (!strcmp($password,""))
         $password = $dbpasswd;
      protect_directory($username,$password,$pathname,$dbname);
   }
   $bbKey = ($bbKey > 1000) ? 0 : $bbKey+1;
   $pathname = "./backup/";
   $filename = "key";
   $fp = fopen($pathname . $filename, "w");
   fputs($fp,$bbKey);
   fclose($fp);

   define('BEGIN_TRANSACTION', 1);
   define('END_TRANSACTION', 2);
   include($phpbb_root_path . 'db/mysql.'.$phpEx);
   $db = new sql_db($dbhost, $dbuser, $dbpasswd, $dbname, false);
   $pathname = "./backup/";
   $filename = "$dbname.gz";

   if(!$db->db_connect_id)   { // check to see if we are unable to connect to the database
?><html>
<head>
   <title>phpBB Backup / Restore v1.06</title>
</head>
<body>
   <font face=Tahoma,Arial,sans-serif size=2 color=#555555>A database has yet to be created</font>
</body><?
      exit;
   }

   $copyright = "<hr><p>phpBB Back Up v1.08 (August 17, 2004)<br> Copyright MMIII - MMIV by TerraFrost. All rights reserved.<br>For help / support / whatever, visit <a href=\"http://www.frostjedi.com/phpbb/viewforum.php?f=6\">Frost Jedi</a>\n</body>\n</html>";

   if (!$db->sql_query("SELECT * FROM ".$table_prefix."config")) { // the database exists, but isn't initialized.
?><html>
<head>
   <title>phpBB Backup / Restore v1.08</title>
</head>
<body>
   <font face=Tahoma,Arial,sans-serif size=2 color=#555555><?
      if (file_exists($pathname . $filename)) {  // check to see if a backup even exists
         if (array_key_exists('key',$_POST) && $_POST['key'] == $bbKey && array_key_exists('username',$_POST) && array_key_exists('password',$_POST)) {  // user is ready to have their credentials authenticated
            $ftp = ftp_connect("localhost");
            if (!@ftp_login($ftp, $_POST['username'], $_POST['password']) || exec("ls . -la | grep 'config.php' | awk '{print $3}'") != $_POST['username']) { // password / username were incorrect
               print "The password or username was incorrect.\n";
               if (function_exists("ftp_close"))
                  ftp_close($ftp);
            } else {
               if (function_exists("ftp_close"))
                  ftp_close($ftp);
               $pathname = "./backup/";
               $filename = "$dbname.gz";

               if ($ftpenable) {
                  $ftp = ftp_connect($ftpname);
                  if (!@ftp_login($ftp,$ftpuser,$ftppass))
                     exit("Restore Failed.  FTP login information in backup.php bad.<p>$copyright");
                  $dirs = explode("/",$ftppath);
                  for ($num=0;$num<count($dirs);$num++)
                     if ($dirs[$num] != "")
                        ftp_chdir($ftp,$dirs[$num]);
                  if (!@ftp_get($ftp,$pathname . "$dbname.gz","$dbname.gz",FTP_BINARY)) {
                     ftp_close($ftp);
                     exit("Restore Failed.  Unable to download backup file.<p>$copyright");
                  }

                  if (function_exists("ftp_close"))
                     ftp_close($ftp);
               }

               exec("gunzip < $pathname" . "$filename | mysql -u $dbuser --password=$dbpasswd $dbname");

               if ($ftpenable)
                  unlink($pathname . "$dbname.gz");

               print "The database has been successfuly restored.";
            }
         } else { ?>
   Please verify your credentials by entering your FTP logon info.<br>
   Also, don't forget to chmod the phpBB root directory 757.<br>
   If you're using FTP transfers, you'll also need to chmod the backup directory 757.<br>
   Once you're done, delete the backup directory, and make a whole new backup.  It may seem redundant, but unless you want to change the file / directory ownership by hand, it will be necessary.<p>

   <form method='POST' action='backup.php'>
      <table border='1' width='300'>
         <tr>
            <td height='20' width='100%'>
               <font face=Tahoma,Arial,sans-serif size=2 color=#555555>Username:</font>
            </td>
            <td height='20'>
               <input type='text' name='username' size='25'>
            </td>
         </tr>
         <tr>
            <td height='20' width='100%'>
               <font face=Tahoma,Arial,sans-serif size=2 color=#555555>Password:</font>
            </td>
            <td height='20'>
               <input type='password' name='password' size='25'>
            </td>
         </tr>
      </table><br>
      <input type='hidden' name='key' value='<?=$bbKey+1;?>'>
      <input type='submit' value='Submit'>
      <input type='reset' value='Reset'>
   </form><?
         }
      } elseif (!file_exists($pathname . $filename))
         print "There is no database to restore!";
      print $copyright;
      exit;
   }

   @include($phpbb_root_path.'common.'.$phpEx);

   //
   // Start session management
   //
   $userdata = session_pagestart($user_ip, PAGE_INDEX);
   init_userprefs($userdata);
   //
   // End session management
   //

   if( !$userdata['session_logged_in'] )
      header('Location: ' . append_sid("login.$phpEx?redirect=backup.$phpEx", true));

   if ( ! (in_array($userdata['username'],$allowedNames) || (count($allowedNames) == 0 && $userdata['user_level'] == ADMIN)) )
      message_die(GENERAL_MESSAGE, $lang['Not_Authorised']);

   $copyright = "<hr><p>phpBB Back Up v1.08 (August 17, 2004)<br> Copyright MMIII - MMIV by TerraFrost. All rights reserved.<br>For help / support / whatever, visit <a href=\"http://www.frostjedi.com/phpbb/viewforum.php?f=6\">Frost Jedi</a>";

   if (isset($_GET['mode']) && $_GET['mode'] == "download")  {  // a random hidden feature.  i may even remove it in future versions!  hooray!
      $pathname = "./backup/";
      $filename = "$dbname.gz";

      header("Content-type: application/x-zip-compressed");
      header("Content-Disposition: attachment; filename=$filename");
      header("Content-Length: " . filesize($pathname . $filename));
      readfile($pathname . $filename);
   } elseif (isset($_GET['mode']) && $_GET['mode'] == "delete") {  // another random hidden feature.  don't use it unless you are *really* sure what you are doing.
      exec("rm -rf backup");

      message_die(GENERAL_MESSAGE, "Backup Deleted.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright");
   } elseif (isset($_POST['mode']) && $_POST['mode'] == "backup" && $_POST['key'] == $bbKey) // create the backup
      create_backup();
   elseif (isset($_POST['mode']) && $_POST['mode'] == "restore" && $_POST['key'] == $bbKey) {  // restore the backup
      $pathname = "./backup/";
      $filename = "$dbname.gz";

      if ($ftpenable) {
         $ftp = ftp_connect($ftpname);
         if (!@ftp_login($ftp,$ftpuser,$ftppass))
            message_die(GENERAL_MESSAGE, "Restore Failed.  FTP login information in backup.php bad.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright");
         $dirs = explode("/",$ftppath);
         for ($num=0;$num<count($dirs);$num++)
            if ($dirs[$num] != "")
               ftp_chdir($ftp,$dirs[$num]);
         if (!@ftp_get($ftp,$pathname . "$dbname.gz","$dbname.gz",FTP_BINARY)) {
            if (function_exists("ftp_close"))
               ftp_close($ftp);
            message_die(GENERAL_MESSAGE, "Restore Failed.  Unable to download backup file.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright");
         }
         if (function_exists("ftp_close"))
            ftp_close($ftp);
      }

      if (file_exists($pathname . $filename)) {

         exec("gunzip < $pathname" . "$dbname.gz | mysql -u $dbuser --password=$dbpasswd $dbname");

         if ($ftpenable)
            unlink($pathname . "$dbname.gz");

         $output = "Restore Completed.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright";
      } else
         $output = "There is nothing to restore! To restore, you will need to first make or a backup.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright";
      message_die(GENERAL_MESSAGE, $output);
   } else {
      $pathname = "./backup/";
      $filename = "age";

      if (file_exists($pathname . $filename)) {
         // the following routine to calculate age isn't 100% accurate, when it comes to the determination of months, as it incorrectly assumes that all months are thirty days.
         $fileage = time() - filemtime($pathname . $filename);
         $dateDivisors = array(31536000,2592000,604800,86400,3600,60,1);
         $dateDescs = array(' year',' month',' week',' day',' hour',' minute',' second');
         for ($num=1;$num<count($dateDivisors) && floor($fileage / $dateDivisors[$num]) == 0;$num++);
         $fileageString = floor($fileage / $dateDivisors[$num]) . $dateDescs[$num] . ((floor($fileage / $dateDivisors[$num]) != 1) ? 's' : '');
         if ($num != 6 && floor(($fileage % $dateDivisors[$num]) / $dateDivisors[$num+1]) != 0)
            $fileageString .= " and " . floor(($fileage % $dateDivisors[$num]) / $dateDivisors[$num+1]) . $dateDescs[$num+1] . ((floor(($fileage % $dateDivisors[$num]) / $dateDivisors[$num+1]) != 1) ? 's' : '');

         $output = javascript_confirm($bbKey + 1) . "The most recent backup was made about $fileageString ago.<p><a href='javascript:javascript_confirm(\"backup\")'>Create New Backup</a><p><a href='javascript:javascript_confirm(\"restore\")'>Restore Backup</a><p>$copyright";
      } else
         $output = javascript_confirm($bbKey + 1) . "A backup has yet to be made. <p><a href='javascript:javascript_confirm(\"backup\")'>Create New Backup</a><p>$copyright";
      message_die(GENERAL_MESSAGE, $output);
   }

   function create_backup() {
      global $dbuser, $dbpasswd, $dbname, $ftpenable, $ftpname, $ftpuser, $ftppass, $ftppath, $copyright;

      $pathname = "./backup/";

      $fp = fopen($pathname . "age", "w");
      fputs($fp,"");
      fclose($fp);

      exec("mysqldump --opt -u $dbuser --password=$dbpasswd $dbname | gzip > " . $pathname . "$dbname.gz");

      if ($ftpenable) {
         $ftp = ftp_connect($ftpname);
         if (!@ftp_login($ftp,$ftpuser,$ftppass))
            @message_die(GENERAL_MESSAGE, "Backup Failed.  FTP login information in backup.php bad.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright");
         $dirs = explode("/",$ftppath);
         for ($num=0;$num<count($dirs);$num++)
            if ($dirs[$num] != "")
               ftp_chdir($ftp,$dirs[$num]);
         if (!@ftp_put($ftp,"$dbname.gz",$pathname . "$dbname.gz",FTP_BINARY)) {
            unlink($pathname . "$dbname.gz");
            if (function_exists("ftp_close"))
               ftp_close($ftp);
            @message_die(GENERAL_MESSAGE, "Backup Failed.  Unable to upload backup file.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright");
         }
         unlink($pathname . "$dbname.gz");
         if (function_exists("ftp_close"))
            ftp_close($ftp);
      }

      @message_die(GENERAL_MESSAGE, "Backup Completed.<p><a href=\"backup.php\">Return to Main Menu</a><p>$copyright");
   }

   function protect_directory($username,$password,$pathname,$name) {
      /* we're only trying to protect the directory from http requests. ftp requests
       * should be secure, as long as you don't allow full access from anonymous
       * accounts
       */
      mkdir($pathname,0777);

      $filename = ".htaccess";

      $fp = fopen($pathname.$filename, "w");
      fputs($fp,"AuthType Basic\n");
      fputs($fp,"AuthName \"Enter Password\"\n");
      fputs($fp,"AuthUserFile " . getcwd() . "/$pathname.$name\n");   // .htpasswd password file
      fputs($fp,"Require user $username");
      fclose($fp);

      /* although the Apache docs regarding .htaccess recomend against placing 
       * AuthUser files in the same directory that you're trying to protect,
       * in this case, it doesn't matter, as no one downloading is really given the
       * password, nor indeed can anyone really access this who shouldn't have
       * the password.
       * 
       * additionally, storing the AuthUser file in the current directory makes this
       * program operate indepenantly of server nuances.
       */

      $filename = ".$name";

      $fp = fopen($pathname . $filename, "w");
      fputs($fp,"$username:" . crypt($password,substr($password,0,2)));
      fclose($fp);
   }

   function javascript_confirm($bbKey) {
      ob_start();
?>

<!-- anchor tags can normally only transfer data to server side scripts via GET.  the following hidden form, in
     conjunction with some of the javascript below the form, allow anchor tags to send data via POST, as well. -->
<form name ="dummyForm" method="post" action="backup.php">
   <input type="hidden" name="mode" value="change.me">
   <input type="hidden" name="key" value="<?=$bbKey;?>">
</form>

<script language="JavaScript">
<!--
   function javascript_confirm(option) {
      var randomizedString = "", reversedString = "", userString="", promptString="Although this script is designed to make " + option + "s easy, they can't be too easy, lest bad things happen.  ";
      var index = 0, size = 5;
      var seedCharacters = "ABCDEFGHJKLNOPQRSTUVXYZ";
      for (var num=0;num<size;num++) {
         index = Math.floor(Math.random() * seedCharacters.length);
         randomizedString = randomizedString + seedCharacters.substring(index,index+1);
      }
      for (var num=size-1;num>=0;num--)
         reversedString += randomizedString.charAt(num);
      userString = (option == "restore") ?
         prompt(promptString + "So, please convert \"" + randomizedString + "\" to lowercase:","") :
         prompt(promptString + "So, please type the reverse of \"" + randomizedString + "\":","");
      if ((option == "restore" && userString.toUpperCase() != userString && userString.toUpperCase() == randomizedString) || (option == "backup" && userString == reversedString)) {
         // this is the javascript i refered to in the above html comment.
         document.dummyForm.mode.value=option;
         document.dummyForm.submit();
      }
   }
-->
</script>
<?
      $output = ob_get_contents();
      ob_end_clean();
      return $output;
   }
?>