<?php
/***************************************************************************
 *                                common.php
 *                            -------------------
 *   begin                : Saturday, Feb 23, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: common.php,v 1.74.2.13 2004/07/15 18:00:34 acydburn Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

//
function unset_vars(&$var)
{
	while (list($var_name, $null) = @each($var))
	{
		unset($GLOBALS[$var_name]);
	}
	return;
}

// variable cleaning mod
function sterilize_key($key)
{
	$key = preg_replace("/\.\./", "", $key);
	$key = preg_replace("/\_\_(.+?)\_\_/", "", $key);
	$key = preg_replace("/^([\w\.\-\_]+)$/", "\\1", $key );
	
	return $key;
}

function sterilize_values($val)
{
	$val = str_replace("&#032;", " ", $val);
	$val = str_replace(chr(0xCA), "", $val);  //Remove sneaky spaces
	
	// Don't want people to comment out stuff in MySQL statements...
	$val = str_replace("#", "&#35;", $val); // used in comments like this: # comment
	$val = str_replace("*", "&#42;", $val); /* used in comments like this one */
	$val = str_replace("--", "&#45;&#45;", $val); // used in comments like this: -- comment
	// to prevent xss issues...
	$val = preg_replace("/<script/i", "&#60;script", $val);
	
	// don't want blank usernames and blank posts...
	$val = trim($val);
	
	if(!get_magic_quotes_gpc())
	{
		$val = addslashes($val);
	}
	return $val;
}
// end variable cleaning mod

//
error_reporting  (E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables
set_magic_quotes_runtime(0); // Disable magic_quotes_runtime

$ini_val = (@phpversion() >= '4.0.0') ? 'ini_get' : 'get_cfg_var';

// Unset globally registered vars - PHP5 ... hhmmm
if (@$ini_val('register_globals') == '1' || strtolower(@$ini_val('register_globals')) == 'on')
{
	$var_prefix = 'HTTP';
	$var_suffix = '_VARS';
	
	$test = array('_GET', '_POST', '_SERVER', '_COOKIE', '_ENV');

	foreach ($test as $var)
	{
		// commeneted out by omega13a (Sept 9, 2004)
		// phpBB-PHP5 mode
		/*if (is_array(${$var_prefix . $var . $var_suffix}))
		{
			unset_vars(${$var_prefix . $var . $var_suffix});
			@reset(${$var_prefix . $var . $var_suffix});
		}*/

		if (is_array(${$var}))
		{
			unset_vars(${$var});
			@reset(${$var});
		}
	}

	if (is_array(${'_FILES'}))
	{
		unset_vars(${'_FILES'});
		@reset(${'_FILES'});
	}

	// commeneted out by omega14a (Sept 9, 2004)
	// phpBB-PHP5 mode
	/*
	if (is_array(${'HTTP_POST_FILES'}))
	{
		unset_vars(${'HTTP_POST_FILES'});
		@reset(${'HTTP_POST_FILES'});
	}*/
}
$starttime = $HTTP_GET_VARS['starttime'];
unset($HTTP_GET_VARS['starttime']);
// commented out by omega13a
// PHP5 with register_long_arrays off?
/*
if (!isset($HTTP_POST_VARS) && isset($_POST))
{
	$HTTP_POST_VARS = $_POST;
	$HTTP_GET_VARS = $_GET;
	$HTTP_SERVER_VARS = $_SERVER;
	$HTTP_COOKIE_VARS = $_COOKIE;
	$HTTP_ENV_VARS = $_ENV;
	$HTTP_POST_FILES = $_FILES;
}*/

//
// addslashes to vars if magic_quotes_gpc is off
// this is a security precaution to prevent someone
// trying to break out of a SQL statement.
//
// changed by omega13a (Sept. 9, 2004)
// phpBB-php5 mod
// variable cleaning mod
if( is_array($_GET) )
{
	while( list($k, $v) = each($_GET) )
	{
		if( is_array($_GET[$k]) )
		{
			while( list($k2, $v2) = each($_GET[$k]) )
			{
				$_GET[sterilize_key($k)][sterilize_key($k2)] = sterilize_values($v2);
			}
			@reset($_GET[sterilize_key($k)]);
		}
		else
		{
			$_GET[sterilize_key($k)] = sterilize_values($v);
		}
	}
	@reset($_GET);
}

if( is_array($_POST) )
{
	while( list($k, $v) = each($_POST) )
	{
		if( is_array($_GET[$k]) )
		{
			while( list($k2, $v2) = each($_POST[$k]) )
			{
				$_POST[sterilize_key($k)][sterilize_key($k2)] = sterilize_values($v2);
			}
			@reset($_POST[sterilize_key($k)]);
		}
		else
		{
			$_POST[sterilize_key($k)] = sterilize_values($v);
		}
	}
	@reset($_POST);
}

if( is_array($_COOKIE) )
{
	while( list($k, $v) = each($_COOKIE) )
	{
		if( is_array($_COOKIE[$k]) )
		{
			while( list($k2, $v2) = each($_COOKIE[$k]) )
			{
				$_COOKIE[sterilize_key($k)][sterilize_key($k2)] = sterilize_values($v2);
			}
			@reset($_COOKIE[sterilize_key($k)]);
		}
		else
		{
			$_COOKIE[sterilize_key($k)] = sterilize_values($v);
		}
	}
	@reset($_COOKIE);
}

//
// Define some basic configuration arrays this also prevents
// malicious rewriting of language and otherarray values via
// URI params
//
$board_config = array();
$userdata = array();
$theme = array();
$images = array();
$lang = array();
$nav_links = array();
$gen_simple_header = FALSE;

include($phpbb_root_path . 'config.'.$phpEx);

if( !defined("PHPBB_INSTALLED") )
{
	header("Location: install/install.$phpEx");
	exit;
}

include($phpbb_root_path . 'includes/constants.'.$phpEx);
include($phpbb_root_path . 'includes/template.'.$phpEx);
include($phpbb_root_path . 'includes/sessions.'.$phpEx);
include($phpbb_root_path . 'includes/auth.'.$phpEx);
include($phpbb_root_path . 'includes/functions.'.$phpEx);
include($phpbb_root_path . 'includes/db.'.$phpEx);

//
// Obtain and encode users IP
//
// I'm removing HTTP_X_FORWARDED_FOR ... this may well cause other problems such as
// private range IP's appearing instead of the guilty routable IP, tough, don't
// even bother complaining ... go scream and shout at the idiots out there who feel
// "clever" is doing harm rather than good ... karma is a great thing ... :)
//
$client_ip = ( !empty($HTTP_SERVER_VARS['REMOTE_ADDR']) ) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ( ( !empty($HTTP_ENV_VARS['REMOTE_ADDR']) ) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : $REMOTE_ADDR );
$user_ip = encode_ip($client_ip);

//
// Setup forum wide options, if this fails
// then we output a CRITICAL_ERROR since
// basic forum information is not available
//
$sql = "SELECT *
	FROM " . CONFIG_TABLE;
if( !($result = $db->sql_query($sql)) )
{
	message_die(CRITICAL_ERROR, "Could not query config information", "", __LINE__, __FILE__, $sql);
}

while ( $row = $db->sql_fetchrow($result) )
{
	$board_config[$row['config_name']] = $row['config_value'];
}

include($phpbb_root_path . 'attach_mod/attachment_mod.'.$phpEx);

if (file_exists('install') || file_exists('contrib'))
{
	message_die(GENERAL_MESSAGE, 'Please ensure both the install/ and contrib/ directories are deleted');
}

//
// Show 'Board is disabled' message if needed.
//
if( $board_config['board_disable'] && !defined("IN_ADMIN") && !defined("IN_LOGIN") )
{
	message_die(GENERAL_MESSAGE, 'Board_disable', 'Information');
}

?>